% CVX: A system for disciplined convex programming.
%   CVX is a modeling framework for building, constructing, and solving
%   disciplined convex programs. 
%
%   cvx_setup        - Sets up and tests the cvx distribution.
%   cvx_error        - Formats text for inclusion in error messages.
%   cvx_license      - License processing for CVX Professional.
%   cvx_startup      - Quietly add CVX to your MATLAB path (for startup).
%   cvx_version      - Returns version and environment information for CVX.
%
%   commands/        - Top-level commands to create and control CVX.
%   functions/       - Additional functions created specifically for CVX.
%   keywords/        - Keywords for declaring variables and objectives
%   lib/             - Code for internal use by CVX.
%   sdpt3/           - The SDPT3 semidefinite-quadratic-linear solver.
%   sedumi/          - The SeDuMi semidefinite-quadratic-linear solver.
%   sets/            - CVX set definitions: nonnegative, semidefinite, etc.
%   shims/           - Interface code to connect CVX to solvers.
%   structures/      - Matrix structure definitions and utilities.
%   doc/             - Documentation (PDF, HTML)

% Copyright 2005-2014 CVX Research, Inc.
% See the file LICENSE.txt for full copyright information.
% The command 'cvx_where' will show where this file is located.
